#import "Citizen.h"
#import <random.h>


@implementation Citizen

- createEnd
{
  if (positionGrid == nil || nhoodProtestValueGrid == nil)
    [InvalidCombination
      raiseEvent: "Agent was created without a world \n"];
  
  worldXSize = [positionGrid getSizeX];
  worldYSize = [positionGrid getSizeY];
  protesting=0;
  return self;				
}


- setPositionGrid: (WrappedListGrid2d *)w localProtestValueGrid: (NhoodProtestValueGrid *)h
{
  if (positionGrid != nil || nhoodProtestValueGrid != nil)
    {
      [InvalidArgument
        raiseEvent:
          "You can only set the world/heat of a heatbug at creation time\n"];
    }
  positionGrid = w;
  nhoodProtestValueGrid = h;

  return self;
}
- setRandomMoveProbability: (float)p
{
  randomMoveProbability = (float) p;
  return self;
}

-setPersonalCondition: (double) c
{
   personalCondition=c;
   return self;
}

-setProtestThreshold: (double) t
{

   threshold=t;
   printf("Protest threshold %f \n",threshold);
   return self;
}

- setX: (int)inX Y: (int)inY
{
  x = inX;
  y = inY;
  [positionGrid addFirst: self atX: x Y: y];
  return self;
}

-(int) getProtest
{
  return protesting;
}

- (double)getUnhappiness
{
   return (100.0*probRulerBad);
}



- updateBeliefs
{
  double discontentHere;
 


  //discontentHere= [nhoodProtestValueGrid getValueAtX: x Y: y];
  
  //Option 2: 
  discontentHere= [nhoodProtestValueGrid measureProtestInVicinityX: (int) x Y: (int) y Radius: 2];

  probRulerBad= (1.0-personalCondition) + 0.01*discontentHere;

  printf("condition: %f perceived discontent here is %f probrulerbad %f \n",personalCondition, discontentHere, probRulerBad);
  if(probRulerBad <0)
       probRulerBad=0;
  if(probRulerBad > 1) probRulerBad=1; 

  return self;

}

- chooseLocation
{
      
  oldx=x; oldy=y;
  if (protesting==1) 
    {
    [nhoodProtestValueGrid removeProtester];
    }

  [positionGrid deleteObject: self atX: x Y: y];
   x=(x+worldXSize + [uniformIntRand getIntegerWithMin: -1L withMax: 1L] ) % worldXSize; 
   y=(y+worldYSize + [uniformIntRand getIntegerWithMin: -1L withMax: 1L] ) % worldYSize;
          
  [positionGrid addFirst: self atX: x Y: y];
  return self;
}

- considerJoiningProtest
{
  int i,j;
  age++;
     if(probRulerBad > threshold)
       {
       	 protesting=1;      
	 [nhoodProtestValueGrid addProtester];
	 // printf("at %d %d age %d Protesting! \n",x,y, age);
	 citizenColor=64;
       }

  else
    {
      citizenColor=65;
      protesting = 0;
      printf("not protesting");
    }

     //if agent changes, he has to cause his neighborhood to be updated
//   for(i=0;i<= 7;i++)
//     {
//     for(j=0; j<= 7; j++)
//       {
//     [nhoodProtestValueGrid UpdateProtestInVicinityX: (int) ((x-3+i+worldXSize)%worldXSize) Y: (int) ((y-3+j+worldYSize)%worldYSize) Radius: 4];
//       }
//     }
  return self; 

}

-step
{
  [self updateBeliefs];
  [self chooseLocation];
  [self considerJoiningProtest];

  return self;
}

- setColor: (Color)c
{
  citizenColor = c;
  return self;
}


- drawSelfOn: (id <Raster>)r
{

  [r drawPointX: x Y: y Color: citizenColor];
  return self;
}

@end
