// Heatbugs application. Copyright (C) 1996-1999 Santa Fe Institute.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

// The HeatSpace is a simple object to represent the heat in the
// world: a spatial variable. HeatSpace inherits most of its behaviour
// from the "Diffuse" space Object.

#import <space/Discrete2d.h>
#import <space.h>
#import "WrappedListGrid2d.h"


@interface Cell: SwarmObject 
{
    int x;
    int y;
   
}
- setX: (int)theX;
- setY: (int)theY;
- (int)getX;
- (int)getY;
@end

@interface NhoodProtestValueGrid: Discrete2d
{ 
  int numProtesters;
  int numPPL;
  WrappedListGrid2d * positionGrid; 
  id <Discrete2d> protestGrid; 

  int radius;
}

+ createBegin: aZone;

- initializeLattice;

-setPositionGrid: p;

-setVisionRadius: (int) rad;

-setNumPPL:(int)n;

- stepRule;

// New methods: Global recordkeeping for total number of protesters
-addProtester;

-removeProtester;

-(double) measureProtestInVicinityX: (int) x Y: (int) y Radius: (int) rad;

// - (HeatValue)findExtremeType: (HeatExtremeType)heat X: (int *)x Y: (int *)y;
@end

